(function () {
  try {
    return angular.module('bonitasoft.ui.widgets');
  } catch(e) {
    return angular.module('bonitasoft.ui.widgets', []);
  }
})().directive('customGanttChart', function() {
    return {
      controllerAs: 'ctrl',
      controller: /**
 * The controller is a JavaScript function that augments the AngularJS scope and exposes functions that can be used in the custom widget template
 * 
 * Custom widget properties defined on the right can be used as variables in a controller with $scope.properties
 * To use AngularJS standard services, you must declare them in the main function arguments.
 * 
 * You can leave the controller empty if you do not need it.
 */
function ctrl($scope) {
        var tasks = $scope.properties.Value;
        var flag = false;
        $scope.$watch('properties.Mode', updateValue);
        $scope.$watch('properties.Value', updateValue, true);
        
		function updateValue(){
		    
		    if($scope.properties.Value.length === 0 && flag){
		        location.reload(true);
		    }
		    
		    var gantt_chart = Gantt("#gantt", tasks, {
		        
			on_click: function (task) {
				console.log("click "+task);
				//console.log("item is "+ JSON.stringify(task));
			},
			
			on_date_change: function(task, start, end) {
				$scope.$apply(function(){
				    $scope.properties.Value[task._index].start = start.format('YYYY-MM-DD');
				    $scope.properties.Value[task._index].end = end.format('YYYY-MM-DD');
				});
		
			},
			on_progress_change: function(task, progress) {
				$scope.$apply(function(){
				    $scope.properties.Value[task._index].progress = progress;
				});
			},
			
			on_view_change: function(mode) {
				//console.log("Mode is "+$scope.properties.Mode);
			}
			
		    });
		    
		    gantt_chart.change_view_mode($scope.properties.Mode);
		    flag = true;
		    
		}
},
      template: '<!-- The custom widget template is defined here\n   - You can use standard HTML tags and AngularJS built-in directives, scope and interpolation system\n   - Custom widget properties defined on the right can be used as variables in a templates with properties.newProperty\n   - Functions exposed in the controller can be used with ctrl.newFunction()\n   - You can use the \'environment\' property injected in the scope when inside the Editor whiteboard. It allows to define a mockup\n     of the Custom Widget to be displayed in the whiteboard only. By default the widget is represented by an auto-generated icon\n     and its name (See the <span> below).\n-->\n \n<span ng-if="environment"><identicon name="{{environment.component.id}}" size="30" background-color="[255,255,255, 0]" foreground-color="[51,51,51]"></identicon> {{environment.component.name}}</span>\n\n	<style>\n		body {\n			font-family: sans-serif;\n		}\n		.container {\n			width: 80%;\n			margin: 1 auto;\n		}\n		.gantt-container {\n			overflow: scroll;\n		}\n		/* custom class */\n		.gantt .bar-milestone .bar-progress {\n			fill: tomato;\n		}\n	</style>\n	\n	<div class="gantt-container">\n		<svg id="gantt" width="400" height="100"></svg>\n	</div>\n'
    };
  });
